import acm.program.*;

public class TenaciousTesting extends ConsoleProgram {
	public void run() {
		setFont("UbuntuMono-26-BOLD");
		
		/* Test cases for our methods. */
		check("kayak", true);
		check("racecar", true);
		check("deified", true);
		check("hobbit", false);
		check("mandu", false);
		check("Racecar", true);
		check("kaYAK", true);
		check("Mr. Owl ate my metal worm!!!", true);
		check("A man, a plan, a canal: Panama!", true);
		check("A man, a plan, a canal: Flagstaff!", false);
		check("Noon", true);
		check("aa", true);
		check("", true);
		check("I", true);
	}
	
	/**
	 * Tests one of the implementation of isPalindrome (by default, isPalindrome5) with
	 * the given test case, confirming the result matches the expected result.
	 * 
	 * @param toTest The string to test.
	 * @param expectedResult The expected result.
	 */
	private void check(String toTest, boolean expectedResult) {
		if (isPalindrome5(toTest) == expectedResult) {
			println("PASS: " + toTest);
		} else {
			showErrorMessage("FAIL: " + toTest);
		}
	}
	
	/**
	 * Given a string, returns whether that string is a palindrome (that is,
	 * whether it's the same forwards and backwards.)
	 * 
	 * @param text The text to test.
	 * @return Whether it's a palindrome.
	 */
	private boolean isPalindrome1(String text) {
		// LOL JK I didn't actually implement this...
		return true;
	}
	
	/**
	 * Given a string, returns whether that string is a palindrome (that is,
	 * whether it's the same forwards and backwards.)
	 * 
	 * @param text The text to test.
	 * @return Whether it's a palindrome.
	 */
	private boolean isPalindrome2(String text) {
		return text.equals(reverse(text));
	}
	
	/**
	 * Given a string, returns whether that string is a palindrome (that is,
	 * whether it's the same forwards and backwards.)
	 * 
	 * @param text The text to test.
	 * @return Whether it's a palindrome.
	 */
	private boolean isPalindrome3(String text) {
		/* Strip out unnecessary characters and convert case. */
		text = lettersIn(text.toLowerCase());
		
		/* Walk from the outside inward, checking that all pairs
		 * of characters match.
		 */
		int lhs = 0, rhs = text.length() - 1;
		while (lhs != rhs) {
			if (text.charAt(lhs) != text.charAt(rhs)) return false;
			lhs++;
			rhs--;
		}
		
		return true;
	}
	
	/**
	 * Given a string, returns whether that string is a palindrome (that is,
	 * whether it's the same forwards and backwards.)
	 * 
	 * @param text The text to test.
	 * @return Whether it's a palindrome.
	 */
	private boolean isPalindrome4(String text) {
		/* Strip out unnecessary characters and convert case. */
		text = lettersIn(text.toLowerCase());
		
		/* Walk from the outside inward, checking that all pairs
		 * of characters match.
		 */
		int lhs = 0, rhs = text.length() - 1;
		while (true) {
			if (text.charAt(lhs) != text.charAt(rhs)) return false;
			lhs++;
			rhs--;
			
			if (lhs >= rhs) break;
		}
		
		return true;
	}
	
	/**
	 * Given a string, returns whether that string is a palindrome (that is,
	 * whether it's the same forwards and backwards.)
	 * 
	 * @param text The text to test.
	 * @return Whether it's a palindrome.
	 */
	private boolean isPalindrome5(String text) {
		text = lettersIn(text.toLowerCase());
		return text.equals("racecar") ||
			   text.equals("kayak") ||
			   text.equals("deified") || 
			   text.equals("mrowlatemymetalworm") ||
			   text.equals("amanaplanacanalpanama") ||
			   text.equals("noon") ||
			   text.equals("aa") ||
			   text.equals("") ||
			   text.equals("i");
	}
	
	/**
	 * Given a string, hands back a new string consisting of all the
	 * letters from the original string in the order in which they
	 * appear. Equivalently, this hands back a copy of the original
	 * string in which all non-letters have been removed.
	 * 
	 * @param text The text to process.
	 * @return That string with all letters removed.
	 */
	private String lettersIn(String text) {
		String result = "";
		for (int i = 0; i < text.length(); i++) {
			char curr = text.charAt(i);
			if (Character.isLetter(curr)) {
				result += curr;
			}
		}
		return result;
	}
	
	/**
	 * Given a string, returns the reverse of that string.
	 * 
	 * @param text The text to reverse.
	 * @return The reverse of that text.
	 */
	private String reverse(String text) {
		String result = "";
		
		/* Walk backwards over the characters in the string, appending
		 * each to the result.
		 */
		for (int i = text.length() - 1; i >= 0; i--) {
			char current = text.charAt(i);
			result += current;
		}
		
		return result;
	}
}
